# rknn_yolo_EAI_pic
#### 简要说明

用于跑EAI提供仓库训练出来的yolov5模型的视频检测例程。
集成了从串口读取红外温度数据，到达阈值后报警并运行rknn模型

需注意运行该例程需要将npu驱动更新为1.7.3版本
 
本项目只适用于EAI-YOLOV5
详情请参考EAI官网：https://www.easy-eai.com/document_details/3/342


## 准备工作
根据EAI给出的教程训练、转化得到rknn模型
有两类检测模型：火焰检测和烟雾检测



## 安装(install)

通过adb连接设备并将编译结果推送至板端，执行以下命令推送，这里板端默认使用/userdata路径

```
adb push install/rknn_yolo_demo /userdata/
```

将前面准备好的RKNN模型推送至板端，这里假设模型名字为 yolov5s_u8.rknn

```
adb push ./yolov5s_u8.rknn /userdata/rknn_yolo_demo/model/yolov5s_u8.rknn
```



## 单图测试执行
详情请了解官网：9.模型部署实例

进入EAI环境之后编译，将编译文件放置到可执行程序，假设是first_yolov5_detect_demo
用下列命令将可执行程序推送到开发板端

```
cp first_yolov5_detect_demo/ /mnt/userdata/ -rf
```

进入办卡运行环境

```
adb shell
```

定位到指定位置后，运行程序

```
./rknn_yolo_EAI
```


## 编译(build)

在项目文件中，根据设备，调整 GCC_COMPILER 参数，终端执行下面命令进行编译

```
./build.sh
```
